// this function verifies disk space in kilobytes
function verifyDiskSpace(dirPath, spaceRequired)
{
  var spaceAvailable;

  // Get the available disk space on the given path
  spaceAvailable = fileGetDiskSpaceAvailable(dirPath);

  // Convert the available disk space into kilobytes
  spaceAvailable = parseInt(spaceAvailable / 1024);

  // do the verification
  if(spaceAvailable < spaceRequired)
  {
    logComment("Insufficient disk space: " + dirPath);
    logComment("  required : " + spaceRequired + " K");
    logComment("  available: " + spaceAvailable + " K");
    return(false);
  }

  return(true);
}

var srDest = 1;

var err = initInstall("Agility: Rapid Harmony Development", "agilmente",
                      "0.0.1");

logComment("initInstall: " + err);

if (verifyDiskSpace(getFolder("Program"), srDest))
{

  //--- jslib install
  const G_VER             = "0.1.44";
  const G_MSG             = "JSLIB v"+G_VER;
  const G_NAME            = "JSLIB";
  const G_CHROME          = "Chrome";
  const G_USER            = "Current User";
  const G_CONTENT         = "/";
  
  const G_JAR_FILE        = "jslib.jar";
  const G_JAR_FILE_APP    = "agile.jar";
  const G_CHROME_DIR      = getFolder(G_USER, "chrome");
  
  const COMNT_1           = "INSTALL FOR JSLIB AS A JAR . . . \n\nInstall: ";
  const COMNT_2           = "INSTALL FOR AGILITY AS A JAR . . .\n\n Install:";

  logComment(COMNT_1 + err);
  
  //--- agilmente install

  addDirectory("Agility",
               "resources",                // jar source folder
               G_CHROME_DIR,               // target folder
               "agilmente");               // target subdir
  
  addFile(COMNT_2, G_JAR_FILE,      G_CHROME_DIR, "");
  addFile(COMNT_2, G_JAR_FILE_APP,  G_CHROME_DIR, "");

  registerChrome(PACKAGE | CONTENT | DELAYED_CHROME,
                 getFolder(G_CHROME_DIR,G_JAR_FILE_APP),
                 "/resources/content/");
  registerChrome(LOCALE | DELAYED_CHROME, 
                 getFolder(G_CHROME_DIR,G_JAR_FILE_APP),
                 "/resources/locale/en-US/");
  registerChrome(SKIN | DELAYED_CHROME, 
                 getFolder(G_CHROME_DIR,G_JAR_FILE_APP),
                 "/resources/skin/");
    
  registerChrome(PACKAGE | CONTENT | DELAYED_CHROME, 
                 getFolder(G_CHROME_DIR, G_JAR_FILE),  G_CONTENT);


  if (err==SUCCESS)
      performInstall();
  else
      cancelInstall(err);
}
else
    cancelInstall(INSUFFICIENT_DISK_SPACE);




