
include ('chrome://jslib/content/io/file.js');
include ('chrome://jslib/content/io/dirUtils.js');
include ('chrome://jslib/content/io/fileUtils.js');


var topAvailableId = 0;

/***
loads the window with information from the disk
***/
function onLoad()
{
  
  var objectListPane = document.getElementById("object-list");
  try{
    //==== write the file
    var du=new DirUtils();
    var fu=new FileUtils();

    fileName = fu.append(du.getMozUserHomeDir(),"harmonyAccounts.props");

    var pFile = new File(fileName);
    if(!pFile.exists()){
      pFile.create();
    }
    pFile.open('r');
    var fileContents = pFile.read();
    pFile.close();

    var fileArray = fileContents.split('\n');
    for(ctr=0;ctr<fileArray.length;ctr++){
      lineArray = fileArray[ctr].split('|');
      if(lineArray.length==5){
        addAccountImpl(lineArray[0],
                       lineArray[1],
                       lineArray[2],
                       lineArray[3],
                       lineArray[4]);
      }
    }



  }
  catch(ex){
    dumpln("new Account Manager "+ex);
  }


  
}

/***
Adds a new account to the list
***/
function addAccount()
{
  var returnObj = new Object();
  returnObj["title"] = "Please enter your account information:";
  returnObj["Server URL:"]   = "localhost:8080";
  returnObj["User Name:"]    = "jhenriksen";
  returnObj["Password:"]     = "jhenriksen";
  returnObj["Organization:"] = "jhenriksen";

  window.openDialog("chrome://agilmente/content/GeneralQuestions.xul",
                    "general-questions",
                    "chrome, modal, centerscreen",
                    returnObj);

  // If the user has pressed cancel, then the password property should have 
  // been set to null in GeneralQuestions.xul.  Return if this is the case, 
  // othewise proceed.
  if (returnObj["Password:"] == null)
    return;

  addAccountImpl(returnObj["Server URL:"],
                 returnObj["User Name:"],
                 returnObj["Password:"],
                 returnObj["Organization:"],
                 "N");
}

/***
Adds a record to the list.  Used by dialog and and file load add.
***/
function addAccountImpl(server,userName,passWord,orgName,defaultLogin)
{
  var rowListTag = document.getElementById("account-list");
  var rowItem = appendTagAndSet(rowListTag,"row","x","y");
  var cur = null;
  var radioItem = appendTagAndSet(rowItem,"radio","id",topAvailableId);
  cur = appendTagAndSet(rowItem,"label","value",server);
  cur.setAttribute("onclick","setSelected('"+topAvailableId+"');");
  cur = appendTagAndSet(rowItem,"label","value",userName);
  cur.setAttribute("onclick","setSelected('"+topAvailableId+"');");
  cur = appendTagAndSet(rowItem,"label","value",passWord);
  cur.setAttribute("onclick","setSelected('"+topAvailableId+"');");
  cur = appendTagAndSet(rowItem,"label","value",orgName);
  cur.setAttribute("onclick","setSelected('"+topAvailableId+"');");

  if(defaultLogin=="Y"){
    rowItem.setAttribute("style","font-weight:bold");
  }

  topAvailableId++;
}

/***
sets the login account to be the account with the radio button lit up.
***/
function selectAccount()
{
  var rowList = getChildList(document.getElementById("account-list"));
  for(var ctr=0;ctr<rowList.length;ctr++){
    rowList[ctr].removeAttribute("style");
  }

  var rGroup = document.getElementById("selected-object-finder");
  rGroup.selectedItem.parentNode.setAttribute("style","font-weight:bold");

  window.arguments[0].wantLogin = "true";  
}

/***
removes the selected item
***/
function removeAccount(itemId)
{
  var rGroup = document.getElementById("selected-object-finder");
  var selectedRadio = rGroup.selectedItem;

  var rowTag = selectedRadio.parentNode;
  rowTag.parentNode.removeChild(rowTag);
}

/***
removes the selected item
***/
function setSelected(itemId)
{
  var group = document.getElementById("selected-object-finder");
  var item  = document.getElementById(itemId);
  group.selectedItem = item;
}


/***
This ok method actually changes the values for the forms, which I think is wrong.
For links and list types it returns the needed data so agilmente-handlers can do the work.

Actually, I like modifing the DOM in here, I have everything I need, it makes sense and it
helps avoid agilmente-handlers from being monolithic
***/
function onOK()
{
  try{
    //==== build the file as a string
    var propString="";
    var rowList = getChildList(document.getElementById("account-list"));
    for(var ctr=0;ctr<rowList.length;ctr++){
      var rowItems = getChildList(rowList[ctr]);
      propString += rowItems[1].value+"|";
      propString += rowItems[2].value+"|";
      propString += rowItems[3].value+"|";
      propString += rowItems[4].value+"|";
      if(rowList[ctr].getAttribute("style")!=null && 
         rowList[ctr].getAttribute("style")!="" ){
        propString += "Y\n";
      }
      else{
        propString += "N\n";
      }
    }

    //==== write the file
    var du=new DirUtils();
    var fu=new FileUtils();

    fileName = fu.append(du.getMozUserHomeDir(),"harmonyAccounts.props");

    var pFile = new File(fileName);
    if(!pFile.exists()){
      pFile.create();
    }
    pFile.open('w');
    pFile.write(propString);
    pFile.close();

  }
  catch(e){dumpln(e);}
}




