/***
Handlers for the create org dialog
***/

var mainQuestion = "";
var compMap = "";
var formList = "";

function onLoad()
{
  //--- fill in the list
  var curObjectName       = window.arguments[0];

  var relDataList = document.getElementById("relDataList");
  var dataSet = window.arguments[0];
  for (var i in dataSet) {
    var newRow = document.createElement("listitem");
    var happyText = dataSet[i];
    var readOnly = "";
    if(happyText.toUpperCase() == happyText){
      //--- aha!  cheap trick, but this shows that the data came from harmony and is
      //  thus a read only field.  Terribly brittle, but saves us a hassle
      readOnly = "X";
    }
    happyText = happyText.toLowerCase();
    if(happyText=="long"){
      happyText="integer";
    }
    if(happyText=="double"){
      happyText="floating point";
    }

    appendTagAndSet(newRow,"listcell","label",i);  // the key
    appendTagAndSet(newRow,"listcell","label",happyText);  // the value
    appendTagAndSet(newRow,"listcell","label",readOnly);  // the value

    dataSet[i] = null;  // clear this now so it's out of the way for later.
    relDataList.appendChild(newRow);
  }

  //--- display the link code
  var linkLabel = document.getElementById("linkCodeLabel");
  linkLabel.setAttribute("value",window.arguments[1]);  // the link code name

}

/***
return the link information to the user
***/
function onOK()
{
  var relDataList = document.getElementById("relDataList");
  var ctr = 0;
  var statusMap = window.arguments[0];

  var needSave=false;

  for(ctr=0;ctr<relDataList.getRowCount()-1;ctr++){  // for some reason the header counts as a row!
    var listItem = relDataList.getItemAtIndex(ctr);
    var childList = getChildList(listItem);
    var key = childList[0].getAttribute("label");
    var value = childList[1].getAttribute("label");
    var readOnly = childList[2].getAttribute("label");

    if(value =="integer"){
      value="long";
    }
    if(value =="floating point"){
      value="double";
    }

    if("X" == readOnly){
      // M E G A  C H E E S E:  Upper case is used to store read only.  Makes a convenient flag.
      value = value.toUpperCase();  
    }
    else{
      needSave = true;
    }
    statusMap[key] = value;
  }
  window.arguments[2].ok = needSave;

  window.close();
}


/***
opens a dialog to get a new field and puts it in the list
***/
function addField()
{
  var result = new Object();
  window.openDialog("chrome://agilmente/content/AddColumnDialog.xul",
                    "add-column-dialog",
                    "chrome, modal, centerscreen",
                    result);

  if(result['noCancel'] != true){
    return;
  }

  var relDataList = document.getElementById("relDataList");
  var newRow = document.createElement("listitem");
  appendTagAndSet(newRow,"listcell","label",result['name']);
  appendTagAndSet(newRow,"listcell","label",result['type']);
  appendTagAndSet(newRow,"listcell","label","");

  relDataList.appendChild(newRow);
}

/***
removes the currently selected field
***/
function cutField()
{
  try{
    var relDataList = document.getElementById("relDataList");
    if(relDataList.selectedIndex != -1){
      var row = relDataList.getItemAtIndex(relDataList.selectedIndex); //buggie!
      var rowList = getChildList(row);
      if("X" != rowList[2].getAttribute("label")){
        relDataList.removeItemAt(relDataList.selectedIndex+2);  // stupid thing is off by 2!!!
      }
      else{
        alert("Rows with an X have already been published and cannot be altered");
      }
    }
  }
  catch(ex){
    dumpln("EditLink.cutField: "+ex);
  }
}

