/***
Handlers for the create org dialog
***/

var mainQuestion = "";
var compMap = "";
var formList = "";

function onLoad()
{
  restartDA();

  mainQuestion = window.arguments[0];
  compMap = window.arguments[1];
  formList = window.arguments[2];

  var qType = getChildValue(mainQuestion,"type");

  var mainDeck = document.getElementById("polymorphBox");

  var questionLabel = document.getElementById("curQuestionDescriptor");
  var descriptiveDialogLabel = "";

  descriptiveDialogLabel += getChildValue(mainQuestion.parentNode,"label");
  descriptiveDialogLabel += " : ";
  descriptiveDialogLabel += getChildValue(mainQuestion,"label");
  descriptiveDialogLabel += " - ";
  descriptiveDialogLabel += qType;
  questionLabel.setAttribute("value",descriptiveDialogLabel);
  

  if(qType.toUpperCase() == "LINK"){
    //--- Build the Link Specifics
    var curDeck  = document.getElementById("subView-LinkCode");
    var linkCodeGroup  = document.getElementById("link-code-group");
    var selectedLinkCode = getChildValue(mainQuestion,"link-code");

    dumpln("selected link code value:"+selectedLinkCode);

    mainDeck.selectedPanel = curDeck;

    //--- find the unique link codes and their descriptions
    var linkCodeMap = new Object();
    var linkDefList = window.arguments[5];
    var ctr=0;
    for(ctr=0;ctr<linkDefList.length;ctr++){
      var curLinkDef = linkDefList[ctr];
      var curLinkCode = getChildValue(curLinkDef,"link-code");
      var curLinkDesc = getChildValue(curLinkDef,"comment");
      linkCodeMap[curLinkCode] = curLinkDesc;
    }

    //--- add a radio box for each one
    for(var i in linkCodeMap){
      var curRadio = appendTagAndSet(linkCodeGroup,"radio","label",""+i);
      curRadio.setAttribute("style","font-weight:bold;");
      if(i==selectedLinkCode){
        curRadio.setAttribute("selected","true");
      }
      appendTagAndSet(linkCodeGroup,"label","value","      "+linkCodeMap[i]);
    }

  }
  else if( (qType == "RDIO") ||
           (qType == "CMBO") ||
           (qType == "CHCK") ||
           (qType.toUpperCase() == "CHECK-BOX") ||
           (qType.toUpperCase() == "RADIO-BOX") ||
           (qType.toUpperCase() == "COMBO-BOX") 
           ){
    //--- Build the list building specifics
    var curDeck  = document.getElementById("subView-MultiChoice");
    mainDeck.selectedPanel = curDeck;

    var optionList    = getChildList(mainQuestion,"available-answer");
    var defaultOption = getChildValue(mainQuestion,"default-answer");

    dumpln(">>"+defaultOption);

    var ctr = 0;
    for(ctr=0;ctr<optionList.length;ctr++){
      //--- add the option
      var curTag = optionList[ctr];
      var isDefault = false;
      if(defaultOption == curTag.firstChild.nodeValue){
        isDefault=true;
      }
      addOption(curTag.firstChild.nodeValue,isDefault);  // add an option for each tag
      //--- mark if it is default
      // JJHNOTE: get the default value!!
    }
  }
  else{
    //--- Build the parameter specifics
    var curDeck  = document.getElementById("subView-Parameters");
    mainDeck.selectedPanel = curDeck;
    var paramPile  = document.getElementById("questionParamPile");

    var curComp = compMap[qType];
    var curParamList = getChildList(curComp,"param");

    if(curParamList.length == 0){
      curDeck  = document.getElementById("subView-NoParams");
      mainDeck.selectedPanel = curDeck;
    }
    else{
      var ctr;

      var curQuestionParamList = getChildList(mainQuestion,"param");
      if(null == curQuestionParamList || curQuestionParamList.length == 0){
        //--- no params have been set for this question yet.  Put them in place now
        for(ctr=0;ctr<curParamList.length;ctr++){
          var curQParamNew    = mainQuestion.ownerDocument.createElementNS(null,"param");
          var curQParamValue  = mainQuestion.ownerDocument.createElementNS(null,"value");
          var curQParamType   = mainQuestion.ownerDocument.createElementNS(null,"type");
          var curQParamFormat = mainQuestion.ownerDocument.createElementNS(null,"format");
  
          curQParamValue.appendChild(mainQuestion.ownerDocument.createTextNode(""));
          curQParamType.appendChild(mainQuestion.ownerDocument.createTextNode(""));
          curQParamFormat.appendChild(mainQuestion.ownerDocument.createTextNode("text"));

          curQParamNew.appendChild(curQParamValue);
          curQParamNew.appendChild(curQParamType);
          curQParamNew.appendChild(curQParamFormat);
          mainQuestion.appendChild(curQParamNew);
        }
        curQuestionParamList = getChildList(mainQuestion,"param");
      }

      for(ctr=0;ctr<curParamList.length;ctr++){
        //--- This is almost certainly not going to work, but I'll give it a try anyway.
        var curParamDesc     = curParamList[ctr];
        var curQuestionParam = curQuestionParamList[ctr];

        var curParamBox = document.createElement("vbox");
        var curParamBoxH = document.createElement("hbox");
        var curParamSpacer = document.createElement("spacer");
        var curParamLabel = document.createElement("fat-label");
        var curParam = document.createElement("textbox");

        curParamBox.appendChild(curParamLabel);
        curParamBox.appendChild(curParamBoxH);
        curParamBoxH.appendChild(curParamSpacer);
        curParamBoxH.appendChild(curParam);

        //dumpElement(curQuestionParam);
        var curQValue = getChildValue(curQuestionParam,"value")
        if(null != curQValue){
          curParam.setAttribute("value",curQValue);
        }

        curParamLabel.setAttribute("value",getChildValue(curParamDesc,"description"));
        curParam.setAttribute("daNodeId",makeNodeDirectlyAccessible( getChildNode(curQuestionParam,"value") ));
        curParam.setAttribute("daNodeIdType",makeNodeDirectlyAccessible( getChildNode(curQuestionParam,"type") ));
        curParam.setAttribute("size","100");
        curParamSpacer.setAttribute("width","30px");
        paramPile.appendChild(curParamBox);

        //dumpElement(curParam);
      }

      //--- put all the available questions in place

      var fctr;
      var qctr;
      var availVarPile  = document.getElementById("available-question-pane");


      for(fctr=0;fctr<formList.length;fctr++){
        var curFormDisplay = formList[fctr];
        var fName = getChildValue(curFormDisplay,"label");
        var localQList = getChildList(curFormDisplay,"form-question");
        for(qctr=0;qctr<localQList.length;qctr++){
          var curQuestionDisplay = localQList[qctr];
          var qName = getChildValue(curQuestionDisplay,"label");

          var displayString = "{value of "+fName+":"+qName+"}";

          var curLI = document.createElement("listitem");
          curLI.setAttribute("label",displayString);
          curLI.setAttribute("ondraggesture","nsDragAndDrop.startDrag(event,moveQuestionNameObserver)");
          availVarPile.appendChild(curLI);

        }
      }

    }

  }

  window.sizeToContent();
}

/***
This ok method actually changes the values for the forms, which I think is wrong.
For links and list types it returns the needed data so agilmente-handlers can do the work.

Actually, I like modifing the DOM in here, I have everything I need, it makes sense and it
helps avoid agilmente-handlers from being monolithic

***/
function onOK()
{
  try{
    var returnCode = window.arguments[3];
    var mainQuestion = window.arguments[0];
    var formList = window.arguments[2];

    var qType = getChildValue(mainQuestion,"type");

    if(qType.toUpperCase() == "LINK"){
      //--- Build the Link Specifics
      var linkCodeGroup  = document.getElementById("link-code-group");
      returnCode.linkCode = linkCodeGroup.selectedItem.label;
      dumpln("returning "+linkCodeGroup.selectedItem.label);
    }
    else if( (qType == "RDIO") ||
             (qType == "CMBO") ||
             (qType == "RDIO") ||
             (qType.toUpperCase() == "CHECK-BOX") ||
             (qType.toUpperCase() == "RADIO-BOX") ||
             (qType.toUpperCase() == "COMBO-BOX") ){
      //--- Build the list building specifics

      clearChildren(mainQuestion,"available-answer");

      var optionList = document.getElementById("option-list");
      var rowList = getChildList(optionList);
      var ctr;
      for(ctr=1;ctr<rowList.length;ctr++){  // start at 1 to skip the headers.
        var childItems = getChildList(rowList[ctr]);
        appendTagWithValue(mainQuestion,"available-answer",childItems[1].value);
        dumpln(">>"+childItems[0].getAttribute("selected"));
        if(childItems[0].getAttribute("selected") == "true"){
          setChildValue(mainQuestion,"default-answer",childItems[1].value);
        }
      }

      dumpElement(mainQuestion);
    }
    else{
      //--- Build the parameter specifics
      var updateParamsList = document.getElementsByTagName("textbox");
      var lctr;

      for(lctr=0;lctr<updateParamsList.length;lctr++){
        var curAnswer = updateParamsList.item(lctr);

        setDANodeValue(curAnswer.getAttribute("daNodeId"),curAnswer.value);
        if(curAnswer.value.indexOf("{")){
          setDANodeValue(curAnswer.getAttribute("daNodeIdType"),"label");
        } 
        else{
          setDANodeValue(curAnswer.getAttribute("daNodeIdType"),"static");
        }
      }
    }

    returnCode.returnCode = "Y";

  }
  catch(e){dumpln(e);}
}

function createComplete()
{
}

/***
This number is the next ID to assign the next added option
***/
var topOptionNumber=0;


/***
This method adds an option (not a link) to a list of available options, using the global
topOptionNumber as a guide.
***/
function addOption(textBoxValue, isDefault)
{
  var optionList = document.getElementById("option-list");
  if(textBoxValue==null){
    textBoxValue="";
  }

  var row    = appendTagAndSet(optionList,"row","id",topOptionNumber);
  var radio  = appendTagAndSet(row,"radio","x","y");  // no attribute needed.
  if(isDefault){
    radio.setAttribute("selected","true");
  }
  var tbox   = appendTagAndSet(row,"textbox","size","50");
  tbox.setAttribute("value",textBoxValue);
  var button = appendTagAndSet(row,"button","label","Delete Option");
  button.setAttribute("onclick","cutOption("+topOptionNumber+")");
  topOptionNumber++;
}

/***
This method deletes the option row with the given option number
***/
function cutOption(optionID)
{
  var optionList = document.getElementById("option-list");
  var rowList = getChildList(optionList);
  var ctr;
  for(ctr=0;ctr<rowList.length;ctr++){
    if(rowList[ctr].getAttribute("id") == optionID){
      rowList[ctr].parentNode.removeChild(rowList[ctr]);
    }
  }
}

