/* Place JavaScript event handlers in this file.
 * Use agilmente-static.js for functons that are not event handlers.
 */


include ('chrome://agilmente/content/model/HarmonyObjectDefinition.js');
include ('chrome://agilmente/content/control.js');

include ('chrome://jslib/content/io/file.js');
include ('chrome://jslib/content/io/dirUtils.js');
include ('chrome://jslib/content/io/fileUtils.js');



var orgListResult = null;            // results of the org list 
var nameArray = null;                // sorted array of the names of the objects in the org.

var curServer = null;                // The server to get harmony service from
var curUser   = null;                // user
var curPass   = null;                // password
var curOrg    = null;                // org

var exportMode = false;              // when this is true, the UI should not be updated to reflect changes
                                     //   in the harmony DOM.  Also, harmony calls should be syncronouse so that
                                     //   code can block on harmony calls

var userDn = null;                   // current users login dn
var orgDn  = null;                   // current users org dn

var orgString = null;                // handy carrying case when creating a new organization

var componentMap = new Object();



function onLoad()
{
  dd ("Application agilmente, 'Agilmente: Rapid Harmony Development' loaded.");
  filter = document.getElementById("object_pane_name_filter");
  filter.addEventListener("keypress",catchFilterEnter,false);

  login();
}

function onUnload()
{
  dd ("Application agilmente, 'Agilmente: Rapid Harmony Development' unloaded.");
}


/***
Login to harmony
***/
function login()
{
  //--- load the properties
  if( !loseChangesOK() ){
    return;
  }


  try{
    //==== read the accounts
    var du=new DirUtils();
    var fu=new FileUtils();
    var foundAccount = false;


    fileName = fu.append(du.getMozUserHomeDir(),"harmonyAccounts.props");

    var pFile = new File(fileName);
    if(!pFile.exists()){
      alert("Welcome to Agilemente");
    }
    pFile.open('r');
    var fileContents = pFile.read();
    pFile.close();

    var fileArray = fileContents.split('\n');
    for(ctr=0;ctr<fileArray.length;ctr++){
      lineArray = fileArray[ctr].split('|');
      if(lineArray.length==5 && lineArray[4]=="Y"){
        // this is the account to use.
        foundAccount = true;
        curServer = lineArray[0];
        dumpln("using server"+curServer);
        harmony = createTemplateDOM("uid=domain-admin,ou=people,o=harmony,dc=harmony");
        curUser = lineArray[1];
        curPass = lineArray[2];
        curOrg  = lineArray[3];
        addDomain(harmony,
                  curUser,
                  curPass,
                  curOrg);
        setAction(harmony,"login");
        var statusBox = document.getElementById("login-status");
        statusBox.value="Searching for Harmony (click the progress bar to cancel)";
        sendHarmonyRequest(harmony, loginResponse);
      }
    }

    if(!foundAccount){
      alert("You do not have a login account specified.  You can select one by clicking File | Manage Harmony Accounts.  The account shown in bold will be used for login.");
    }
  }
  catch(ex){
    dumpln("new Account Manager "+ex);
  }






  /*
  fProps = new FastProps("harmonyProps");
  fProps.addProperty("prefsUserName");
  fProps.addProperty("prefsUserPassword");
  fProps.addProperty("prefsOrganization");
  fProps.addProperty("prefsServer");
  fProps.readProps();

  curServer = fProps.getValue("prefsServer")

  objectMap = new Object();

  if (fProps.getValue("prefsUserName")!=null) {
    harmony = createTemplateDOM("uid=domain-admin,ou=people,o=harmony,dc=harmony");
    addDomain(harmony,
              fProps.getValue("prefsUserName"),
              fProps.getValue("prefsUserPassword"),
              fProps.getValue("prefsOrganization"));
    setAction(harmony,"login");
  } else {
    alert("Welcome to Agilmente");
    alert("You must set your login information under Edit|Preferences before you can log in");
  }
  var statusBox = document.getElementById("login-status");
  statusBox.value="Searching for Harmony (click the progress bar to cancel)";
  sendHarmonyRequest(harmony, loginResponse);
  */
  
}

/**
Process the login response
**/
function loginResponse(newDoc)
{
  nlist = newDoc.getElementsByTagName("id");
  if (nlist.length<1) {
    statusText = "Not Logged In";
  } else {
    userDn=nlist.item(0).firstChild.nodeValue;

    orgDn = "o=" + (userDn.split(",o=")[1]);
    statusText = "Logged In As "+curUser+" on "+curServer;
  }
  var statusBox = document.getElementById("login-status");
  statusBox.value=statusText;
  importXml();
}


/**
Login to the organization
**/
function importXml()
{
  harmony = createTemplateDOM(userDn);
  setAction(harmony,"get");
  appendOrganization(harmony,orgDn);
  sendHarmonyRequest(harmony, importXmlResponse);
}

/***
Load the object labels out of the org
***/
function importXmlResponse(newDoc)
{
  objectList = newDoc.getElementsByTagName("object-name-list");
  objectList = objectList[0].getElementsByTagName("object-label");
  nameArray = new Array();
  for (ctr=0;ctr<objectList.length;ctr++) {
    //-- get the current label
    olabel = objectList.item(ctr);

    //-- make a definition holder for it.
    curDef = new HarmonyObjectDefinition();
    curDef.setObjectLabel(olabel);

    //-- get the name out of it.
    name = getChildValue(olabel,"object-tag");
    nameArray[nameArray.length] = name;

    //-- map the name to the definition
    objectMap[name]=curDef;
  }

  nameArray.sort();

  updateObjectPane();

  loadComponentList();
}

/**
Get the forms available on an object
**/
function loadComponentList()
{
  harmony = createTemplateDOM(userDn);
  addComponentTag(harmony);
  setAction(harmony,"getAll");
  filter = addFilterTag(harmony);
  addSortFilter(filter,"name","ASCENDING","");
  addSortFilter(filter,"group","ASCENDING","");
  //dumpln("request comp list"+new Date().getTime());

  sendHarmonyRequest(harmony, loadComponentListResponse);
}


/**
Get the components for a given org
**/
function loadComponentListResponse(newDoc)
{
  //dumpln("loadComponentListResponse Start: "+new Date().getTime());
  try {
    compList = newDoc.getElementsByTagName("component");
    compUITree = document.getElementById("tree-direct-add");

    curGroupNode = null;
    curGroupName = null;

    for (ctr=0;ctr<compList.length;ctr++) {
      curComp = compList.item(ctr);
      var name  = getChildValue(curComp,"name");
      var code  = getChildValue(curComp,"code");
      var desc  = getChildValue(curComp,"description");
      var group = getChildValue(curComp,"group-name");

      //--- save the DOM for later
      componentMap[name] = curComp;
      if(code != null){
        componentMap[code] = curComp;
      }

      //--- put a representation in the tree
      if (curGroupName != group) {
        curGroupName = group;
        treeItem  = document.createElement("treeitem");
        treeItem.setAttribute("container","true");
        treeItem.setAttribute("open","true");

        treeRow   = document.createElement("treerow");
        treeRow.setAttribute("properties","needBold");
        treeCell1 = document.createElement("treecell");
        treeCell1.setAttribute("label",curGroupName);
        treeRow.appendChild(treeCell1);
        treeChildren = document.createElement("treechildren");

        treeItem.appendChild(treeRow);
        treeItem.appendChild(treeChildren);
        treeRow.appendChild(treeCell1);

        curGroupNode = treeChildren;
        compUITree.appendChild(treeItem);
      }

      treeItem  = document.createElement("treeitem");
//      treeItem.setAttribute("treeallowevents","true");
      treeRow   = document.createElement("treerow");
//      treeRow.setAttribute("treeallowevents","true");
      treeCell1 = document.createElement("treecell");
      treeCell1.setAttribute("label",name);
      treeCell2 = document.createElement("treecell");
      treeCell2.setAttribute("label",desc);

      treeItem.appendChild(treeRow);
      treeRow.appendChild(treeCell1);
      treeRow.appendChild(treeCell2);
      curGroupNode.appendChild(treeItem);
    }
  } catch (e) {
    dumpln("ERROR>"+e);
    getStackTrace();
  }
  //dumpln("loadComponentListResponse End: "+new Date().getTime());
}



/**
Get the forms available on an object
**/
function loadObjectDefinition()
{
  try {
    //--- Load the forms
    var harmony1 = createTemplateDOM(userDn);
    addFormAvailability(harmony1,curObjectName);
    setAction(harmony1,"listLink");
    filter = addFilterTag(harmony1);
    addSortFilter(filter,"order","ASCENDING","numeric");

    //--- Load the link definitions
    var harmony2 = createTemplateDOM(userDn);
    var plTag = addPowerLink(harmony2, null, null);  // no link code, no comment
    addPowerLinkSide(plTag, curObjectName);
    setAction(harmony2,"getLinkDefineList");

    var harmonyCommandList = createCommandListDOM();
    addToCommandList(harmonyCommandList,harmony1.firstChild,null,null);
    addToCommandList(harmonyCommandList,harmony2.firstChild,null,null);

    sendHarmonyRequest(harmonyCommandList, loadObjectDefinitionResponse);
  } catch (e) {
    dumpln("EXC: loadFormAvailabilityList "+e);
    getStackTrace();
  }
}

/**
Get the forms available on an object
**/
function loadObjectDefinitionResponse(newDoc)
{
  try {
    newDoc = firstChild(newDoc);  // get to the harmony node.
    
    //---- Handle the forms in the first response
    var firstResponse = firstChild(newDoc);
    firstResponse = firstChild(firstResponse);
    fqMap = new Object();
    var formList = getChildList(firstResponse,"form-availability");

    var properFormList = new Array();
    for (ctr=0;ctr<formList.length;ctr++) {
      // save the form
      var realForm = firstChild(firstChild(formList[ctr])); // down to the form.
      properFormList[properFormList.length] = realForm;

      // save the questions in the form
      var qList = getChildList(realForm,"form-question");

      for (qctr=0;qctr<qList.length;qctr++) {
        var fq = qList[qctr];
	restoreAbsentTags(fq);  // restore any removed tags
        var fqId = getChildValue(fq,"id");

        // map the id to the question
        fqMap[fqId] = fq;
      }
    }

    var harmonyObject = objectMap[curObjectName];    
    harmonyObject.setFormList(properFormList);
    harmonyObject.setFormQuestionMap(fqMap);
    harmonyObject.setHarmonyObjectDefDOM(newDoc);


    //---- Handle the link definitions in the second response
    var secondResponse = nextSibling(firstResponse);
    var lDefList = getChildList(secondResponse,"power-link");
    var linkKeyArray = new Array();  // array entries are 'linkCode:farObject'
    var linkCodeMap = new Object();  // array entries are 'linkCode:farObject'

    for (ctr=0;ctr<lDefList.length;ctr++) {  // spin through the link definitions
      var linkDef = lDefList[ctr];

      var linkCodeName    = getChildValue(linkDef,"link-code");
      var linkCodeComment = getChildValue(linkDef,"comment");

      linkKeyArray[linkKeyArray.length] = makeNodeDirectlyAccessible(linkDef);
      //--- link code has to point to def using that link code, it doesn't matter
      //    which one
      if(linkCodeMap[linkCodeName] == null){
        linkCodeMap[linkCodeName] = linkKeyArray[linkKeyArray.length-1];
      }
    }

    //---- Now that we've found all these lovely things, save them to the object
    harmonyObject.setLinkKeyList(linkKeyArray);
    harmonyObject.setLinkCodeMap(linkCodeMap);

    //---- update the view with the new data.
    if(!exportMode){
      updateEditAreaView();
    }
  } 
  catch (e) {
    dumpln("EXC: loadFormAvailabilityListResponse "+e);
    getStackTrace();
  }
}

/***
Restores tags that have been removed by harmony for optimization when 
the value of the tag's enclosed text is 'N'.  These tag currently
include: required, in-summary, hidden and is-unique-key.
***/
function restoreAbsentTags(formQuestion)
{
  var absentTags = ["required", "in-summary", "hidden", "is-unique"];

  // Check for the absence of each tag.  If it isn't present 
  // then add it with the value of 'N'.
  for (var i = 0; i < absentTags.length; i++) {
    nl = formQuestion.getElementsByTagName(absentTags[i]);

    if (nl.length > 0)
      continue;

    var restoredTag = formQuestion.ownerDocument.createElementNS(null, absentTags[i]);
    restoredTag.appendChild(formQuestion.ownerDocument.createTextNode("N"));   
    formQuestion.appendChild(restoredTag);
  }
}


var listItemPlaceHolder = null;

/***
Called when the org is loaded or when the filter text is modified.
***/
function updateObjectPane()
{
  //dumpln("updateObjectPane Start: "+new Date().getTime());

  document.getElementById("progressMeter").setAttribute("mode","undetermined");;

  var objectPane = document.getElementById("power-object-pane");
  var filterTag = document.getElementById("object_pane_name_filter");
  var hidePower  = document.getElementById("hidePowerObjects").checked;
  var hideSystem = document.getElementById("hideSystemObjects").checked;
  var linkablePalette = document.getElementById("linkable-object-palette");

  filter="("+filterTag.value+")";

  clearChildren(objectPane,"listitem");  // get rid of the existing children
  clearChildren(linkablePalette,"listitem");  // get rid of the existing children

  //--- add the new entries to main object selection list.
  for (ctr=0;ctr<nameArray.length;ctr++) {
    //-- add to the primary list under certain conditions.
    if (nameArray[ctr] != null && nameArray[ctr].match(filter)) {
      hdef = objectMap[ nameArray[ctr] ];

      power = hdef.getPowerStatus();
      if ( (power==true && hidePower==false) ||
           (power==false && hideSystem==false) ) {
        var listItem = hdef.getListItemProxy();
        objectPane.appendChild(listItem);
      }
    }
    //--- always add to the linking list.  This is a bit wasteful, but convenient.
    var newLinkPaletteItem = document.createElement("listitem");
    newLinkPaletteItem.setAttribute("ondraggesture","nsDragAndDrop.startDrag(event,moveLinkObjectObserver)");
    newLinkPaletteItem.setAttribute("label",nameArray[ctr]);
    linkablePalette.appendChild(newLinkPaletteItem);
  }

  updateObjectPaneSaveValues();

  document.getElementById("progressMeter").setAttribute("mode","determined");;
  //dumpln("updateObjectPane End: "+new Date().getTime());

  if(objectPane.selectedIndex == -1){
    updatePalette();
  }
}

/***
spins through the list of items in the object pane and ensures that their save/pub values are correct
***/
function updateObjectPaneSaveValues()
{
  var objectPane = document.getElementById("power-object-pane");

  //--- set the images as needed for save and publish
  itemList = getChildList(objectPane,"listitem");
  for (ctr=0;ctr<itemList.length;ctr++) {
    curListItem = itemList[ctr];

    curObj = objectMap[ curListItem.firstChild.getAttribute('label') ];

    var img = curListItem.childNodes.item(1).firstChild;
    if (curObj.needSave) {
      img.setAttribute("src","chrome://agilmente/content/images/needSave.gif");
    } else {
      img.removeAttribute("src");
    }

    var img = curListItem.childNodes.item(2).firstChild;
    if (curObj.needPublish) {
      img.setAttribute("src","chrome://agilmente/content/images/needPub.gif");
    } else {
      img.removeAttribute("src");
    }
  }
}

/***
Called on keypress for the filter.  If the keypress is an enter update the object pane,
otherwise ignore it.
***/
function catchFilterEnter(e)
{
  if (e.keyCode == 13) {
    updateObjectPane();
  }
}

function testFeature()
{
  var fp = new FastProps("harmonyProps");
  fp.writeProps();
  fp.readProps();

}

//function checkOrg()
//{
//  alert(prettyPrintDom(orgListResult));
//}


/***
If the user presses the spinner, stop the spinner.  Hopefully someday we'll be able
to actually stop the work, too.
***/
function requestCancel()
{
  if (confirm("Cancel the current request?")) {
    document.getElementById("progressMeter").setAttribute("mode","determined");;
  }
}


/***
More dumb scoping issues.  This would rather be a method on form-list-editor,
but it can't find the method there
***/
function removeQuestion(questionId, formId)
{
  var curObj = getCurObject();
  curObj.removeQuestionFromForm(questionId, formId)
}


/***
accepts the name of an object and makes a tag name out of it.  
Next it creates the object in harmony.
Then is re-gets the org, but not using the login code because it must preserve any unsaved changes,
  instead it remakes the call, looking only for the new CO and puts that into the list of known objects.
  
***/
function removeCurrentPowerObject()
{
  try {
    objectMap[curObjectName]=null;

    harmony = createTemplateDOM(userDn);
    addCustomObjectDefinition(harmony, curObjectName);
    setAction(harmony,"undefine");

    sendHarmonyRequest(harmony, updateObjectList);
  } catch (e) {
    dumpln("EXC: loadFormAvailabilityList "+e);
    getStackTrace();
  }
}



/***
accepts the name of an object and makes a tag name out of it.  
Next it creates the object in harmony.
Then is re-gets the org, but not using the login code because it must preserve any unsaved changes,
  instead it remakes the call, looking only for the new CO and puts that into the list of known objects.
  
***/
function createNewPowerObject(newObjName)
{
  try {
    harmony = createTemplateDOM(userDn);
    addCustomObjectDefinition(harmony, newObjName);
    setAction(harmony,"define");

    sendHarmonyRequest(harmony, updateObjectList);
  } catch (e) {
    dumpln("EXC: loadFormAvailabilityList "+e);
    getStackTrace();
  }
}

/***
get the definition response and send up for the org again, this time with the new
object present.
***/
function updateObjectList()
{
  harmony = createTemplateDOM(userDn);
  setAction(harmony,"get");
  appendOrganization(harmony,orgDn);
  sendHarmonyRequest(harmony, updateObjectListResponse);
}

/***
Updates the availabile object list
***/
function updateObjectListResponse()
{
  objectList = newDoc.getElementsByTagName("object-name-list");
  objectList = objectList[0].getElementsByTagName("object-label");

  //-- clear the name array so it can be rebuilt
  nameArray.length = 0;  

  //--- load any new object names that weren't there previously
  for (ctr=0;ctr<objectList.length;ctr++) {
    //-- get the current label
    olabel = objectList.item(ctr);

    name = getChildValue(olabel,"object-tag");
    if(objectMap[name] == null){
      //-- make a definition holder for it.
      curDef = new HarmonyObjectDefinition();
      curDef.setObjectLabel(olabel);

      //-- map the name to the definition
      objectMap[name]=curDef;
    }

    //-- put the name back in no matter what (all of this is because javascrip arrays are messy)
    nameArray[nameArray.length] = name;
  }

  nameArray.sort();

  updateObjectPane();
}



/***
Publish your changes to this object name
***/
function publish(objName)
{
  try{
    //===================== OBJECT LABEL SECTION =========
    //--- get the object being updated
    var curObj = objectMap[objName];
  
    //--- first we build the command list
    var harmonyCommandList = createCommandListDOM();

    //--- first we build up a command that will update this object label.
    var harmony = createTemplateDOM(userDn);
    setSubject(harmony, curObj.getObjectLabel() );
    setAction(harmony,"update");

    //--- then we add it to the command list
    addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
    
    //===================== FORM UPDATE SECTION =========
    var localFormList = curObj.getFormList();
    var fctr = 0;
    for(fctr=0;fctr<localFormList.length;fctr++){
      var curWorkingForm = localFormList[fctr];
      setChildValue(curWorkingForm,"order",fctr);

      // Set default-object-type to the name of the object that owns
      // these forms, if it's not already set
      var defaultObjectType = getChildValue(curWorkingForm, "default-object-type");
      if (defaultObjectType == null) {
        defaultObjectType = harmonyCommandList.createElementNS(null,"default-object-type");
        curWorkingForm.appendChild(defaultObjectType);
        defaultObjectType.appendChild(harmonyCommandList.createTextNode(objName));
      }

      var curWorkingId = getChildValue(curWorkingForm,"id");
      if(curWorkingId == null || (""+curWorkingId).charAt(0) == 'T'){
        //--- now build a command that will define any currently undefined forms 
        //    -- If the form doesn't have an id number, ensure that all questions inside it also lack id numbers.
        //    -- send a form create, followed by a form link.  Build the command list variables appropriately
        setChildValue(curWorkingForm,"id",null);
        var localQList = getChildList(curWorkingForm,"form-question");
        var qctr = 0;
        for(qctr=0;qctr<localQList.length;qctr++){
          var localQ = localQList[qctr];
          setChildValue(localQ,"id",null);
          setChildValue(localQ,"order",qctr);
        }

        //--- make a call to create the form and add it to the list

        harmony = createTemplateDOM(userDn);
        setSubject(harmony, curWorkingForm );
        setAction(harmony,"create");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N","newForm"+fctr);  // list, harmony xml, no results, don't put it in a variable

        //--- make a call to link it to the object and add it to the list
        harmony = createTemplateDOM(userDn);
        addFormAvailability(harmony, objName, "[[newForm"+fctr+":/harmony/result/form/id]]" );  // dom, objec to append to, varname and address to pull id from.
        setAction(harmony,"addLink");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
      }
      else{
        //--- now build a command that will update any existing forms.
        //    -- if the form has an id number, check each question under it.
        //    -- if the sub-question has an id number that doesn't start with T and the form_type_id matches
        //    -- the current forms id, then the question is ok.  Otherwise, nuke the questions id.
        //    -- send a form update.

        var localQList = getChildList(curWorkingForm,"form-question");
        var qctr = 0;
        for(qctr=0;qctr<localQList.length;qctr++){
          var localQ = localQList[qctr];
          setChildValue(localQ,"order",qctr);
          
          if( (getChildValue(localQ,"form-type") != curFormId) ||   // if the question came from another type
              ((getChildValue(localQ,"id")).charAt(0) == 'T')  ){   // or the question id is a temporary id.
            setChildValue(localQ,"id",null);
          }
        }

        //--- make a call to create the form and add it to the list
        harmony = createTemplateDOM(userDn);
        setSubject(harmony, curWorkingForm );
        setAction(harmony,"update");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N","newForm"+fctr);  // list, harmony xml, no results, don't put it in a variable
      }
    }

    //-- handle removing the forms
    var localNukeArray = curObj.getRemovedFormList();
    var lnaCtr = 0;
    for(lnaCtr=0;lnaCtr<localNukeArray.length;lnaCtr++){
      //--- make a call to unlink forms that are no longer part of the object
      //    (Should I also undefine the form?  Too dangerous)
      var formToNuke = localNukeArray[lnaCtr];
      harmony = createTemplateDOM(userDn);
      addFormAvailability(harmony, objName, getChildValue(formToNuke,"id") );  // dom, objec to append to, varname and address to pull id from.
      setAction(harmony,"removeLink");
      addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable

    }

    //===================== LINK UPDATE SECTION =========
    var localLinkList = curObj.getLinkKeyList();    
    var ldctr=0;

    sortLinkDefListForPublish(localLinkList);  // puts them in the order the actions should happen
    for(ldctr=0;ldctr<localLinkList.length;ldctr++){
      var curLinkDefKey = localLinkList[ldctr];
      var curLinkDef = getDANode(curLinkDefKey);
      //--- publish what is linked to what
      if(curLinkDef.getAttribute("needAction") != "" && 
         curLinkDef.getAttribute("needAction") != null){
        harmony = createTemplateDOM(userDn);
        setSubject(harmony, curLinkDef);
        setAction(harmony,curLinkDef.getAttribute("needAction"));
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
        curLinkDef.removeAttribute("needAction");
      }

      // what if set rel data then add links?


      //--- publish any relationship data updates
      var statusTag = getChildNode(curLinkDef,"status");
      if(statusTag != null &&
         statusTag.getAttribute("needAction") != "" && 
         statusTag.getAttribute("needAction") != null){
        //--- note that the status tag controls this action, though the whole link is sent
        harmony = createTemplateDOM(userDn);
        setSubject(harmony, curLinkDef);
        setAction(harmony,statusTag.getAttribute("needAction"));
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
        statusTag.removeAttribute("needAction");
      }

    }


    //--- then we fire off the list
    objectMap[objName] = null;  // removing this now means that the question id numbers will be updated.
    sendHarmonyRequest(harmonyCommandList, publishResponse);
  }
  catch(e){
    dumpln("publish: "+e);
    getStackTrace();
  }
}

/***
Response to Publish your changes to this object name
***/
function publishResponse(responseDoc)
{
  var localObjectPane = document.getElementById("power-object-pane");
  dumpln("had index:"+localObjectPane.selectedIndex);

  updateObjectList();  // really only being done so that we get the object with the proper ids present.
}


/***
Display a dialog for editing the given question id
***/
function showQuestionEditWindow(questionId)
{
  var curQuestion = getCurObject().getFormQuestion(questionId);
  var curFormList = getCurObject().getFormList();
  var needUpdateObject = new Object();
  needUpdateObject.returnCode = "N";
  var specificParams = new Array();

  var qType = getChildValue(curQuestion,"type");
  if(qType.toUpperCase()=="LINK"){
    var curObject = getCurObject();
    var linkDefList = curObject.getLinkKeyList();
    sortLinkDefListForDisplay(linkDefList);

    var lctr = 0;
    var groupLinkCode = null;
    var curGroupNode = treeChildren;

    for(lctr=0;lctr<linkDefList.length;lctr++){
      var curDefKey = linkDefList[lctr];
      var curLinkDefNode = getDANode(curDefKey);
      specificParams[specificParams.length]=curLinkDefNode;
    }
  }
  
  window.openDialog("chrome://agilmente/content/QuestionEditor.xul",
                    "question_params",
                    "chrome, modal, centerscreen",
                    curQuestion,
                    componentMap,
                    curFormList,
                    needUpdateObject,
                    new Date(),
                    specificParams);
  if(needUpdateObject.returnCode != "Y"){
    return;
  }

  //--- make the updates
  if(qType.toUpperCase()=="LINK"){
    dumpln("updating to:"+needUpdateObject.linkCode);
    setChildValue(curQuestion,"link-code",needUpdateObject.linkCode);
  }

  //--- need to move the logical component param changes from QuestionEditor to here.
  declareCurObjectHasChanged();
}


/***
removes the currently selected link.  If the user has selected a link code row, all 
links between the current object and all objects on that link code will be removed.
***/
function removeCurrentLink()
{
  try{
    var theTree  = document.getElementById("link-definition-tree");
    var colList  = getChildList(theTree.view.getItemAtIndex(theTree.currentIndex).firstChild);
    var targetObject = colList[0].getAttribute("label");  
    var targetLinkCode = colList[5].getAttribute("label");  
    var curObject = getCurObject();

    dumpln("removing link: "+targetObject+"  "+targetLinkCode);

    var linkDefList = curObject.getLinkKeyList();

    sortLinkDefListForDisplay(linkDefList);

   // linkCodeDefPane = document.getAnonymousElementByAttribute(this,"anonid","link-code-definition-pane");
    var lctr = 0;
    var groupLinkCode = null;
    var curGroupNode = treeChildren;

    linkCodeCommentPile = new Object();

    for(lctr=0;lctr<linkDefList.length;lctr++){
      var curDefKey = linkDefList[lctr];
      var curLinkDefNode = getDANode(curDefKey);

      var curLinkCode = getChildValue(curLinkDefNode,"link-code")
      var curFarSide  = getFarSideForLinkDef(curLinkDefNode);
      if(curLinkCode == targetLinkCode &&
         (targetObject == curObjectName ||   // mark removed is doing mass removal
          targetObject == curFarSide)){      // mark removed if direct match

        curLinkDefNode.setAttribute("needAction","undefine");
      }
    }

    //--- let the view know to refresh itself
    declareCurObjectHasChanged();
    updateEditAreaView();

  }
  catch(ex){
    dumpln("removeCurrentLink :"+ex);
    getStackTrace();
  }

}

/***
edit the relationship data for a link.
***/
function editCurrentLink()
{

  try{
    var theTree  = document.getElementById("link-definition-tree");
    var colList  = getChildList(theTree.view.getItemAtIndex(theTree.currentIndex).firstChild);
    var targetObject = colList[0].getAttribute("label");  
    var targetLinkCode = colList[5].getAttribute("label");  
    var curObject = getCurObject();

    var curObj = getCurObject();
    var defMap = curObj.getLinkCodeMap();

    var curLinkDefNode = getDANode(defMap[targetLinkCode]);
    var statusNode = getChildNode(curLinkDefNode,"status");
    statusNode = firstChild(statusNode);

    if(statusNode==null){
      statusNode = getChildNode(curLinkDefNode,"status");
      var localChild = document.createElementNS(null,targetLinkCode);
      statusNode.appendChild(localChild);
      statusNode = localChild;
    }

    dumpln(statusNode.tagName);

    var statusMap = new Object();

    if(statusNode != null){
      var itemList = getChildList(statusNode);

      var ictr=0;
      for(ictr=0;ictr<itemList.length;ictr++){
        var item = itemList[ictr];
        var key = item.tagName;
        var value = item.firstChild.nodeValue;
        statusMap[key]=value;
      }
    }

    var returnCode = new Object();
    returnCode.ok = false;
    window.openDialog("chrome://agilmente/content/EditLink.xul",
                      "edit-link-dialog",
                      "chrome, modal, centerscreen",
                      statusMap,
                      targetLinkCode,
                      returnCode);

    if(returnCode.ok != true){
      //--- changes canceled.
      return;
    }

    //--- clear out the tag
    clearChildren(statusNode,null);

    //--- put all the data back into (with the changes)
    for (var i in statusMap) {
      dumpln("adding status name:"+i);
      dumpln("using status name:"+makeTagName(i));
      appendTagWithValue( statusNode, makeTagName(i), statusMap[i]); //JJHNOTE
    }
    statusNode.parentNode.setAttribute("needAction","updateRelationshipDataStructure");
    declareCurObjectHasChanged();
  }
  catch(ex){
    dumpln("editCurrentLink :"+ex);
    getStackTrace();
  }

}

/***
Removes an object from the local cache so that it will be re-loaded next time it is viewed.
Also requests and immediate re-viewing.
***/
function abandonCurrentObject()
{
  getCurObject().abandonChanges();
  updateObjectList();  // This is probably overkill, but I want to make sure everything is reloaded 
}

/***
Export a command list from this organization
***/
function exportOrg()
{
  var returnObject = new Object();
  window.openDialog("chrome://agilmente/content/ExportDialog.xul",
                    "export-dialog",
                    "chrome, modal, centerscreen",
                    nameArray,
                    returnObject);

  if(returnObject["code"] != "OK"){
    return;
  }

  var comment    = returnObject.comment;
  var fileName   = returnObject.file;
  var objectList = returnObject.list;

  exportMode = true;
  try{

    //==== load each object
    var ctr = 0;
    for(ctr=0;ctr<objectList.length;ctr++){
      curObjectName = objectList[ctr];
      var curObject = getCurObject();
      dumpln("==================== loading "+curObjectName);
      if(curObject.needsDataLoad()){
        loadObjectDefinition();
      }
    }

    //==== generate the xml

    //--- first we build the command list
    var harmonyCommandList = createCommandListDOM();

    //--- build a crate object call for each object
    var ctr = 0;
    for(ctr=0;ctr<objectList.length;ctr++){
      curObjectName = objectList[ctr];
      var curObject = getCurObject();

      //--- a command to create this power object
      dumpln("==================== create object "+curObjectName);
      harmony = createTemplateDOM("USERDN");
      addCustomObjectDefinition(harmony, curObjectName);
      setAction(harmony,"define");
      addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
      
      
      //--- a command that will update this object label.
      dumpln("==================== label object "+curObjectName);
      var harmony = createTemplateDOM("USERDN");
      setSubject(harmony, curObject.getObjectLabel() );
      setAction(harmony,"update");
      addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
    }

    for(ctr=0;ctr<objectList.length;ctr++){
      curObjectName = objectList[ctr];
      var curObject = getCurObject();

      var localFormList = curObject.getFormList();
      var fctr = 0;
      for(fctr=0;fctr<localFormList.length;fctr++){
        var curWorkingForm = localFormList[fctr];
        curWorkingForm.removeChild(getChildNode(curWorkingForm,"id"));    // remove invalid tag
        curWorkingForm.removeChild(getChildNode(curWorkingForm,"table")); // remove invalid tag


        //--- now build a command that will define any currently undefined forms 
        //    -- If the form doesn't have an id number, ensure that all questions inside it also lack id numbers.
        //    -- send a form create, followed by a form link.  Build the command list variables appropriately
        setChildValue(curWorkingForm,"id",null);
        var localQList = getChildList(curWorkingForm,"form-question");
        var qctr = 0;
        for(qctr=0;qctr<localQList.length;qctr++){
          var localQ = localQList[qctr];
          localQ.removeChild(getChildNode(localQ,"id"));
        }

        //--- make a call to create the form and add it to the list
        harmony = createTemplateDOM("USERDN");
        setSubject(harmony, curWorkingForm );
        setAction(harmony,"create");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N","newForm"+fctr);  // list, harmony xml, no results, don't put it in a variable

        //--- make a call to link it to the object and add it to the list
        harmony = createTemplateDOM("USERDN");
        addFormAvailability(harmony, curObjectName, "[[newForm"+fctr+":/harmony/result/form/id]]" );  // dom, objec to append to, varname and address to pull id from.
        setAction(harmony,"addLink");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
      }

    }
    for(ctr=0;ctr<objectList.length;ctr++){
      curObjectName = objectList[ctr];
      var curObject = getCurObject();

      //===================== LINK UPDATE SECTION =========
      var localLinkList = curObject.getLinkKeyList();    
      var ldctr=0;

      sortLinkDefListForPublish(localLinkList);  // puts them in the order the actions should happen
      for(ldctr=0;ldctr<localLinkList.length;ldctr++){
        var curLinkDefKey = localLinkList[ldctr];
        var curLinkDef = getDANode(curLinkDefKey);
        //--- publish what is linked to what
        harmony = createTemplateDOM("USERDN");
        setSubject(harmony, curLinkDef);
        setAction(harmony,"define");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable

        //--- publish any relationship data updates
        var statusTag = getChildNode(curLinkDef,"status");
        //--- note that the status tag controls this action, though the whole link is sent
        harmony = createTemplateDOM("USERDN");
        setSubject(harmony, curLinkDef);
        setAction(harmony,"updateRelationshipDataStructure");
        addToCommandList(harmonyCommandList,harmony.firstChild,"N",null);  // list, harmony xml, no results, don't put it in a variable
        statusTag.removeAttribute("needAction");
      }
    }


    //==== write the file
    
    var pFile = new File(fileName);
    if(!pFile.exists()){
      pFile.create();
    }
    pFile.open('w');
    pFile.write(prettyPrintDom( harmonyCommandList ));
    pFile.close();
    
    dumpln("========== EXPORT COMPLETE =========");

  }
  catch(ex){
    dumpln("export: "+ex);
    getStackTrace();
  }


  exportMode = false;

}

/***
Export a command list from this organization
***/
function importOrg()
{
  var returnObj = new Object();
  window.openDialog("chrome://agilmente/content/ImportDialog.xul",
                    "create-new-org",
                    "chrome, modal, centerscreen",
                    returnObj);

  dumpln("using "+returnObj.path);
  if(returnObj.path == null){
    dumpln("no path data found.");
    return;
  }

  try{
    var du=new DirUtils();
    var fu=new FileUtils();

    //--- load the xml string

    dumpln("loading file");
    var pFile = new File(returnObj.path);
    pFile.open('r');
    var fileContents = pFile.read();
    pFile.close();

    //--- replace the values are requested
    fileContents = fileContents.split("USERDN").join(userDn);  // MONSTER replace USERDN with userDn

    dumpln("prep to send");
    dp = new DOMParser();
    hcl = dp.parseFromString(fileContents,"text/xml");
    sendHarmonyRequest(hcl,importOrgComplete);
  }
  catch(ex){
    dumpln("import org: "+ex);
  }

}

/***
Handle org import completion
***/
function importOrgComplete()
{
  alert('org import complete');
}


/***
Create a new organization
***/
function createOrg()
{
  var returnObj = new Object();
  window.openDialog("chrome://agilmente/content/NewOrg.xul",
                    "create-new-org",
                    "chrome, modal, centerscreen",
                    returnObj);

  //--- Before proceeding, check that the org really was created.
  if (returnObj.uname == null)
    return;

  var du=new DirUtils();
  var fu=new FileUtils();

  //--- load the xml string
  path = fu.chromeToPath("chrome://agilmente/content/xml/createOrgCommandList.xml");
  var pFile = new File(path);
  pFile.open('r');
  var fileContents = pFile.read();
  pFile.close();

  //--- replace the values are requested
  uname = returnObj.uname;
  pword = returnObj.pword;
  oname = returnObj.oname;

  fileContents = fileContents.replace("ORGNAME",oname);
  fileContents = fileContents.replace("USERNAME",uname);
  fileContents = fileContents.replace("PASSWORD",pword);

  orgString = "";
  orgString += curServer+"|";
  orgString += uname+"|";
  orgString += pword+"|";
  orgString += oname+"|";
  orgString += "N\n";

  //--- send the create request
  dp = new DOMParser();
  hcl = dp.parseFromString(fileContents,"text/xml");
  sendHarmonyRequest(hcl,createOrgComplete);
}

function createOrgComplete()
{
  //--- read the old accounts file
  try{
    //==== write the file
    var du=new DirUtils();
    var fu=new FileUtils();

    fileName = fu.append(du.getMozUserHomeDir(),"harmonyAccounts.props");

    var pFile = new File(fileName);
    if(!pFile.exists()){
      pFile.create();
    }
    pFile.open('r');
    var fileContents = pFile.read();
    pFile.close();

    fileContents+=orgString;

    pFile.open('w');
    pFile.write(fileContents);
    pFile.close();

  }
  catch(ex){
    dumpln("new Account Manager "+ex);
  }


  alert("Organization Create Completed.  If you want to log in to your new org, select the new org under File | Manage Harmony Accounts.");
}


/***
Manage the harmony accouns this user is aware of.
***/
function manageAccounts()
{
  var retObj = new Object();
  window.openDialog('chrome://agilmente/content/AccountManager.xul','prefs','chrome, modal, centerscreen',retObj);

  if(retObj.wantLogin == "true"){
    login();
  }
}

/***
returns true if there are changes and it ok to lose them or if ther are no changes.  
Returns false only if there are changes and user has decided to cancel the current action.
***/
function loseChangesOK()
{
  var needSave = false;
  if(nameArray==null){
    dumpln("NO NAME ARRAY");
    return true;
  }

  for(var ctr=0;ctr<nameArray.length;ctr++){
    var curName = nameArray[ctr];
    if(objectMap[curName].needsSaveOrPublish()){
      needSave=true;
    }
  }
  if(needSave){
    return confirm("You are about to log in to a new account.  Unpublished changes will be lost.  Would you like to continue?");
  }
  else{
    return true;
  }

}


/***
Displays a recent selection of the log in a display window
***/
function emergencyLogDisplay()
{
  var returnObj = new Object();
  returnObj.value = curLog;

  window.openDialog("chrome://agilmente/content/EvilLog.xul",
                    "emergency-log",
                    "chrome, modal, centerscreen",
                    returnObj);
}




//================================ Test Data Builder

/***
Create a new organization
***/
function createReportFodder()
{
  var du=new DirUtils();
  var fu=new FileUtils();

  exportMode = true;

  var data = new Array();
  data[data.length]="A";
  data[data.length]="B";
  data[data.length]="C";
  data[data.length]="D";
  data[data.length]="E";
  data[data.length]="F";
  data[data.length]="G";
  data[data.length]="H";
  data[data.length]="I";
  data[data.length]="J";
  data[data.length]="K";
  data[data.length]="L";
  data[data.length]="M";
  data[data.length]="N";
  data[data.length]="O";
  data[data.length]="P";
  data[data.length]="Q";
  data[data.length]="R";
  data[data.length]="S";
  data[data.length]="T";
  data[data.length]="U";
  data[data.length]="V";
  data[data.length]="W";
  data[data.length]="X";
  data[data.length]="Y";
  data[data.length]="Z";
  
  var ctr=0;
  var inctr=0;
  var outctr=0;

  for(outctr=0;outctr<26;outctr++){
    for(inctr=0;inctr<26;inctr++){
      var testDate = "7/31/";
      testDate= testDate+(1900+ctr);
      dumpln(">>"+data[outctr]+"  "+data[inctr]+"  "+ctr+"  "+testDate);
      ctr++;
      makeRecord(data[outctr],data[inctr],ctr,testDate);
    }
  }
}



function makeRecord(colA, colB, colC, colD)
{
  //--- load the xml string
  var du=new DirUtils();
  var fu=new FileUtils();
  path = fu.chromeToPath("chrome://agilmente/content/xml/createFodder.xml");
  var pFile = new File(path);
  pFile.open('r');
  var fileContents = pFile.read();
  pFile.close();

  fileContents = fileContents.replace("USER_DN",userDn);
  fileContents = fileContents.replace("USER_DN",userDn);
  fileContents = fileContents.replace("TEXT_A",colA);
  fileContents = fileContents.replace("TEXT_B",colB);
  fileContents = fileContents.replace("NUMBER_VALUE",colC);
  fileContents = fileContents.replace("DATE_VALUE",colD);


  //--- send the create request
  dp = new DOMParser();
  hcl = dp.parseFromString(fileContents,"text/xml");
  sendHarmonyRequest(hcl,newRecordComplete);
}

function newRecordComplete()
{
}
