include ('chrome://agilmente/content/util/Util.js');


/***
Constructor
***/
function HarmonyObjectDefinition()
{
  //--- object label xml snippet
  this.objectLabel = new Object();
  this.needSave    = false;
  this.needPublish = false;
  this.formQuestionMap = new Object();
  this.nukedFormList = new Array();
  this.linkKeyList = null;
  this.linkCodeMap = null;

  //--- method definition
  this.setObjectLabel = setObjectLabel;
  this.setFormQuestionMap = setFormQuestionMap;
  this.setFormList = setFormList;

  this.setLinkKeyList = setLinkKeyList;
  this.getLinkKeyList = getLinkKeyList;
  this.setLinkCodeMap = setLinkCodeMap;
  this.getLinkCodeMap = getLinkCodeMap;

  this.needsDataLoad = needsDataLoad;
  this.needsSaveOrPublish = needsSaveOrPublish;

  this.getObjectLabel = getObjectLabel;
  this.getFormList = getFormList;
  this.getForm = getForm;
  this.getFormQuestionMap = getFormQuestionMap;
  this.getFormQuestion = getFormQuestion;
  this.getPowerStatus = getPowerStatus;
  this.removeQuestionFromForm = removeQuestionFromForm;
  this.removeForm = removeForm;
  this.getRemovedFormList = getRemovedFormList;
  this.addQuestionToFormAtIndex = addQuestionToFormAtIndex;
  this.abandonChanges = abandonChanges;

  this.addNewForm = addNewForm;
  this.addNewQuestion = addNewQuestion;
  this.isSane = isSane;

  this.getListItemProxy = getListItemProxy;
  this.updated = updated;
  this.declarePublished = declarePublished;

  this.needSaveImage = false;
  this.needPubImage = false;
  
  this.harmonyObjectDefDOM = null;
  this.setHarmonyObjectDefDOM = setHarmonyObjectDefDOM;
}
  


function setObjectLabel(val)      {  this.isSane();  this.objectLabel = val; }
function setFormList(val)         
{  
  this.isSane();  
  if(val==null || val.length==0) {
    dumpln("attempting to set null form list");
    getStackTrace();
  } 
  this.formList = val; 
}

function setFormQuestionMap(val)  {  this.isSane();  this.formQuestionMap = val; }


function getObjectLabel()         {  this.isSane();  return this.objectLabel;    }
function getFormList()             
{
  this.isSane();
  if(this.formList==null){
    // WARNING: This is an asyncronous call.
    //  this call will still return null, the handler will go off and load the data in
    //  in the backgroup, then re-update the UI when the data is present
    dumpln("THE FORMLIST SHOULD NOT BE NULL");
    getStackTrace();
  }

  return this.formList;
}

/***
If this object is caches and/or has changes, it should not be reloaded.
if needsDataLoad returns true, the data should be loaded from harmony
***/
function needsDataLoad()
{
  if(this.formList==null){
    return true;
  }
  return false;
}


function getFormQuestionMap()
{
  this.isSane();
  return this.formQuestionMap;
}

/***
Tries to get the form using the id
***/
function getForm(formId)
{
  this.isSane();
  var list = this.getFormList();
  var curForm = null;

  for(ctr=0;ctr<list.length;ctr++){
    curForm = list[ctr];
    if(getChildValue(curForm,"id") == formId){
      return curForm;
    }
  }

  return null;
}

/***
Use the map and return the form question for the given id.
***/
function getFormQuestion(formQuestionId)
{
  this.isSane();
  try{
    var map = this.getFormQuestionMap();
    return map[formQuestionId];
  }
  catch(e){
    dumpln("EXC: "+e);
  }
}

/***
Called by the view if the view as updated any of the snippets stored in this object.
***/
function updated(hasBeenUpdated)
{
  this.isSane();
  if(this.needsUpdate == true){  // we already know this has changed, don't worry about it.
    return;
  }

  if(hasBeenUpdated){
    this.needSave=true;
    this.needPublish=true;
    this.needsUpdate=true;
    updateObjectPaneSaveValues();
  }
}

/***
called when the changes have been published.
***/
function declarePublished()
{
  this.isSane();
  this.needSave=false;
  this.needPublish=false;
  this.needsUpdate=false;
  updateObjectPaneSaveValues();
}

/***
WEIRD!  This object knows how to build a proxy of itself for the list.  It isn't
really a view object, so I'm holding it here until I find a better place for it.
Scripting is messy.  :(
***/
function getListItemProxy()
{
  this.isSane();
  if(this.listItem==null){
    this.listItem = document.createElement("listitem");
    this.listItem.setAttribute("style","-moz-box-align: start;");
    //this.listItem.setAttribute("onselect","");

    var cell1  = document.createElement("listcell");
    cell1.setAttribute("label",nameArray[ctr]);
    //var cell2  = document.createElement("listcell");
  
    cell2Img  = document.createElement("image");
    this.needSaveImage = cell2Img;
  
    cell2Img.setAttribute("validate","never");
    //cell2Img.setAttribute("src","chrome://agilmente/content/images/needSave.gif");
    cell2Img.setAttribute("width","10");
    cell2Img.setAttribute("height","10");
    var cell2Box  = document.createElement("box");
    cell2Box.setAttribute("style","-moz-box-align: center;");
    cell2Box.setAttribute("align","center");
    cell2Box.appendChild(cell2Img);
  
  
    var cell3Img  = document.createElement("image");
    this.needPubImage = cell3Img;
    cell3Img.setAttribute("validate","never");
    //cell3Img.setAttribute("src","chrome://agilmente/content/images/needPub.gif");
    cell3Img.setAttribute("width","10");
    cell3Img.setAttribute("height","10");
    var cell3Box  = document.createElement("box");
    cell3Box.setAttribute("style","-moz-box-align: center;");
    cell3Box.setAttribute("align","center");
    cell3Box.appendChild(cell3Img);
  
    this.listItem.appendChild(cell1);
    this.listItem.appendChild(cell2Box);
    this.listItem.appendChild(cell3Box);
  }

  return this.listItem;
}

/***
Returns true if this is a power object
***/
function getPowerStatus()
{
  this.isSane();
  if("Y" == getChildValue(this.objectLabel,"is-custom")){
    return true;
  }
  else{
    return false;
  }
}

/***
Creates a new question object in the harmony document and puts it into the 
question map for display.  At the end of this method the new form-question node 
is still not attached to any node.
***/
function addNewQuestion(type)
{
  this.isSane();

  var harmonyDoc = this.formList[0].ownerDocument;

  var id = "T"+new Date().getTime();
  var newQ      = harmonyDoc.createElementNS(null,"form-question");

  var qId    = harmonyDoc.createElementNS(null,"id");
  qId.appendChild(harmonyDoc.createTextNode(id));

  var qLabel    = harmonyDoc.createElementNS(null,"label");
  qLabel.appendChild(harmonyDoc.createTextNode("Click here to update the question label"));

  var qType     = harmonyDoc.createElementNS(null,"type");
  qType.appendChild(harmonyDoc.createTextNode(type));

  var qRequired = harmonyDoc.createElementNS(null,"required");
  qRequired.appendChild(harmonyDoc.createTextNode("N"));
  
  var qSummary = harmonyDoc.createElementNS(null,"in-summary");
  qSummary.appendChild(harmonyDoc.createTextNode("Y"));

  newQ.appendChild(qId);
  newQ.appendChild(qLabel);
  newQ.appendChild(qType);
  newQ.appendChild(qRequired);
  newQ.appendChild(qSummary);

  this.formQuestionMap[id]=newQ;
  this.updated(true);
  return id;
}

/***
Add a new form to this object
***/
function addNewForm()
{
  this.isSane();

  var harmonyDoc = document;

  var id = "T"+new Date().getTime();
  var newF      = harmonyDoc.createElementNS(null,"form");

  var fId    = harmonyDoc.createElementNS(null,"id");
  fId.appendChild(harmonyDoc.createTextNode(id));

  var fLabel    = harmonyDoc.createElementNS(null,"label");
  fLabel.appendChild(harmonyDoc.createTextNode("click here to update the label"));

  var fHelp     = harmonyDoc.createElementNS(null,"help-text");
  fHelp.appendChild(harmonyDoc.createTextNode("click here to update the help text"));

  newF.appendChild(fId);
  newF.appendChild(fLabel);
  newF.appendChild(fHelp);

  this.formList[this.formList.length]=newF;
  this.updated(true);
  return id;
}


/***
Tries to get the form using the id
***/
function removeForm(formId)
{
  this.isSane();

  var formId = alterId(formId,null);

  var foundIt=false;
  var newFormList = new Array();

  //--- The irritating way to manage arrays.  Ask Javascript why this is needed.
  for(ctr=0;ctr<this.formList.length;ctr++){
    var curForm = this.formList[ctr];
    var cfId = ""+getChildValue(curForm,"id");
    if(cfId != formId){
      //--- This is NOT the one to nuke.  Keept it around in the newFormList!!!
      newFormList[newFormList.length] = curForm;
    }
    else{
      //--- This IS the form to nuke.  Move it to the nukable form list.
      foundIt = true;
      if(!(getChildValue(curForm,"id")==null ||
           getChildValue(curForm,"id").charAt(0) == 'T')){  // no id or Temp id means, not really in harmony
        //--- its really in harmony, nuke it.
        this.nukedFormList[this.nukedFormList.length] = curForm;
      }
    }
  }

  if(foundIt == false){
    dumpln("Could not find form "+formId+" to delete it");
  }

  for(ctr=0;ctr<newFormList.length;ctr++){
    this.formList[ctr] = newFormList[ctr];
  }
  this.formList.length = this.formList.length-1;
  this.updated(true);

}


/***
returns a list of forms that have been removed from this object and should be
disconnected from the form availability.
***/
function getRemovedFormList()
{
  return this.nukedFormList;
}



/***
Set the list of link keys for this object
***/
function setLinkKeyList(linkKeyListVal)
{
  this.linkKeyList = linkKeyListVal;
}
/***
Get the list of link keys for this object
***/
function getLinkKeyList()
{
  return this.linkKeyList;
}

/***
Set the list of link keys for this object
***/
function setLinkCodeMap(linkCodeMapVal)
{
  this.linkCodeMap = linkCodeMapVal;
}
/***
Get the list of link keys for this object
***/
function getLinkCodeMap()
{
  return this.linkCodeMap;
}



/***
Remove question from form
***/
function removeQuestionFromForm(questionId, formId)
{
  this.isSane();

  questionId = alterId(questionId,null);
  formId = alterId(formId,null);

  var curForm = this.getForm(formId);
  var curQuestion = this.getFormQuestion(questionId);

  var list = getChildList(curForm,"form-question");
  for(ctr=0;ctr<list.length;ctr++){
    curQ = list[ctr];
    curQId = getChildValue(curQ,"id");
    if(curQId==questionId){
      curForm.removeChild(curQ);
    }
  }

  this.updated(true);

}



/***
Remove question from form
***/
function addQuestionToFormAtIndex(questionId, formId, indexId)
{
  try{
    this.isSane();
    var curForm = this.getForm(formId);
    var curQuestion = this.getFormQuestion(questionId);
    var targetQuestion = this.getFormQuestion(indexId);
  
    curForm.insertBefore(curQuestion,targetQuestion);
    this.updated(true);
  }
  catch(e){
    dumpln("add question to form: "+e);
  }
}

/***
Javascript really really wants you to lose track of your information.  The lack of
private methods makes it so that I can call any of these functions without an object
of reference and hence get nulls where I expect values.  By calling this method with
paranoide insistency, I can protect against these kinds of shenanigans.
***/
function isSane()
{
  if(this==null){
    dumpln("You are calling a method directlly instead of using this.method.  Therefore nothing is defined.");
    getStackTrace();
  }
}

/***
Stores the whole DOM response tree for later reference
***/
function setHarmonyObjectDefDOM(value)
{
  try{
    this.isSane();
    this.harmonyObjectDefDOM = value;
  }
  catch(e){
    dumpln("add question to form: "+e);
  }
}
/***
Returns the whole DOM response tree for later reference
***/
function getHarmonyObjectDefDOM()
{
  try{
    this.isSane();
    return this.harmonyObjectDefDOM;
  }
  catch(e){
    dumpln("add question to form: "+e);
  }
  return null;
}

/***
Abandons the internal cache so that this object will be re-loaded from harmony next
time it is viewed.
***/
function abandonChanges()
{
  try{
    this.isSane();
    this.formList=null;
    this.needSave=false;
    this.needPublish=false;
    this.needsUpdate=false;
  }
  catch(e){
    dumpln("add question to form: "+e);
  }
  return null;
}

/***
returns true if this object needs to be saved or published
***/
function needsSaveOrPublish()
{
  try{
    this.isSane();
    if(this.needSave || this.needPublish){
      return true;
    }
  }
  catch(e){
    dumpln("needsSaveOrPublish: "+e);
  }
  return false;

}












