/***
The purpose of all of this is to hack around an XBL bug that prevents the constructor being
called properly if an XBL tag contains another XBL tag.  I can set properties, but not
call methods, so I'll set a direct access id number that can later be used to figure out
what needs to be done.
***/
 

/** a list of unique id numbers to nodes containing text that should be editable **/
var directAccessNodeList = new Array();

/***
Takes a node and looks for the 'directAccessId' attribute.  If it isn't there, then this
node is added to the directAccessNodeList and the index of the node in the list is
set as an attribute on the node.  The nodes directAccessId attribute is returned in either
case.
***/
function makeNodeDirectlyAccessible(daNode)
{
  var daNodeIndex = daNode.getAttribute("directAccessId");

  if(daNodeIndex == null){
    var indexId = directAccessNodeList.length;
    directAccessNodeList[indexId] = daNode;
    daNode.setAttribute("directAccessId",indexId);
    return indexId;
  }
  else{
    //--- this is needed for sub windows where the directAccessNodeList may be wiped from
    //      on viewing to the next
    directAccessNodeList[daNodeIndex] = daNode;
    return daNodeIndex;
  }

}

/**
Get the value of a directly accessible node.
**/
function getDANodeValue(deNodeId)
{
  var curNode = directAccessNodeList[deNodeId];
  if(curNode == null){
    getStackTrace();
    dumpln("getDANodeValue: couldn't find node using null id");
    return null;
  }
  return curNode.firstChild.nodeValue;
}

/**
Get the node of a directly accessible node.
**/
function getDANode(deNodeId)
{
  var curNode = directAccessNodeList[deNodeId];
  if(curNode == null){
    getStackTrace();
    dumpln("getDANode: couldn't find node using null id");
    return null;
  }
  return curNode;
}

/**
Set the value of a directly accessible node.
**/
function setDANodeValue(deNodeId, newVal)
{
  var curNode = directAccessNodeList[deNodeId];
  if(curNode == null){
    dumpln("setDANodeValue: couldn't find node: "+deNodeId);
    return null;
  }
  curNode.firstChild.nodeValue = newVal;
  declareCurObjectHasChanged();
}


/**
If things are messy, try unmessing them.
**/
function restartDA()
{
  directAccessNodeList = null;
  directAccessNodeList = new Array();
}
