
var p = new XMLHttpRequest();
var dparse = new DOMParser();
var dserial = new XMLSerializer();
var xmlDoc; 
var currentResponseHandler;

var workCounter = 0;

var timeSS;
var timePS;
var timePE;
var holdLabel=null;

var workingWindow = null;

/***
Add the id name of any tag that you would like disabled while in communication 
with harmony
***/
var disableWhenWorkingList = new Array();


var oldStyle = new Object();

/***
Sends an asynchronous request to harmony.
@param harmony the harmony dom node
@param handlerFunc the function to call when the results come back
***/
function sendHarmonyRequest(harmony, handlerFunc)
{
  if(null != document.getElementById("progressMeter")){
    document.getElementById("progressMeter").setAttribute("mode","undetermined");;
    var workLabel= document.getElementById("login-status");

    if(workLabel!=null && workLabel.getAttribute("value") != "WORKING"){
      holdLabel = workLabel.getAttribute("value");
      workLabel.setAttribute("value","WORKING");
      workLabel.setAttribute("style","font-weight: bold");
    }

    workCounter++;
  }

  if(null != disableWhenWorkingList){
    for(dctr=0;dctr<disableWhenWorkingList.length;dctr++){
      var curTag = document.getElementById(disableWhenWorkingList[dctr])
      var curStyle = curTag.getAttribute("style");

      oldStyle[curTag]=curStyle;
      curTag.setAttribute("style","cursor: wait");
    }
  }

  try{
    currentResponseHandler = handlerFunc;
    if(isDebugMode()){
      dumpln( "=== REQUEST ==================================\n" );
      dumpln( prettyPrintDom(harmony) );
    }

    p.onload = receiveHarmonyResponse;

    netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    //--- curServer is defined in agilmente-handlers
    // true => async
    // false => syncronous
    var asyncVal = !exportMode;  // if we are not exporting, keep the ui active.
                                 // if we are exporting, be syncronous.
    p.open("POST", "http://"+curServer+"/harmony/harmony",asyncVal,"","");  

    timeSS = new Date().getTime();
    p.send(harmony);
  }
  catch(ex){
    dumpln("Send Exception: "+ex);
  }
}

/***
When a harmony response arrives, do the processing and call the user requested method
***/
function receiveHarmonyResponse(e)
{
  timePS = new Date().getTime();
  newDoc = dparse.parseFromString(p.responseText,"text/xml");
  timePE = new Date().getTime();

  dumpln("    harmony spent: "+(timePS-timeSS));
  dumpln("    parser spent:  "+(timePE-timePS));

  if(isDebugMode()){
    dumpln( "=== RESPONSE ==================================\n" );
    dumpln( prettyPrintDom(newDoc) );
  }
  currentResponseHandler(newDoc);

  if(null != document.getElementById("progressMeter")){
    workCounter--;
    if(workCounter==0){
      var workLabel= document.getElementById("login-status");
      if(workLabel!=null){
        workLabel.setAttribute("value",holdLabel);
        workLabel.setAttribute("style","");
      }

      if(null != disableWhenWorkingList){
        for(dctr=0;dctr<disableWhenWorkingList.length;dctr++){
          var curTag = document.getElementById(disableWhenWorkingList[dctr])
          var curStyle = oldStyle[curTag];

          curTag.setAttribute("style","");
        }
      }


      document.getElementById("progressMeter").setAttribute("mode","determined");
    }
  }
}

