
/* Place JavaScript event handlers in this file.
 * Use agilmente-static.js for functons that are not event handlers.
 */
 
var fProps = null;

function dumpln(msg)
{
  dump(msg+"\n");
}

function testFastProps()
{
  dumpln("=== start fast props test ===");
  //--- define the props object.
  fProps = new FastProps("TestFastProps");
  fProps.addProperty("prefsUserName");
  fProps.addProperty("prefsUserPassword");
  fProps.addProperty("prefsOrganization");
  fProps.addProperty("prefsServer");

  //--- load the ui
  userNameTag   = document.getElementById("prefsUserName");
  userPWordTag  = document.getElementById("prefsUserPassword");
  userOrgTag    = document.getElementById("prefsOrganization");
  userServerTag = document.getElementById("prefsServer");

  userNameTag.value="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  userPWordTag.value="1234567890";
  userOrgTag.value="!@#$%^&*()";
  userServerTag.value="[]\;',./|}{:?><";

  //--- write a file
  fProps.writeProps();

  //--- clear the tags.
  userNameTag.value="";
  userPWordTag.value="";
  userOrgTag.value="";
  userServerTag.value="";

  //--- read the props back into the UI.
  fProps = new FastProps("TestFastProps");
  fProps.addProperty("prefsUserName");
  fProps.addProperty("prefsUserPassword");
  fProps.addProperty("prefsOrganization");
  fProps.addProperty("prefsServer");
  fProps.readProps();

  var errctr = 0;

  if("ABCDEFGHIJKLMNOPQRSTUVWXYZ" != fProps.getValue("prefsUserName")){     dumpln("BAD FASTPROPS TEST: getValue 1"); errctr++; }
  if("1234567890"                 != fProps.getValue("prefsUserPassword")){ dumpln("BAD FASTPROPS TEST: getValue 2"); errctr++; }
  if("!@#$%^&*()"                 != fProps.getValue("prefsOrganization")){ dumpln("BAD FASTPROPS TEST: getValue 3"); errctr++; }
  if("[]\;',./|}{:?><"            != fProps.getValue("prefsServer")){       dumpln("BAD FASTPROPS TEST: getValue 4"); errctr++; }

  if("ABCDEFGHIJKLMNOPQRSTUVWXYZ" != userNameTag.value){   dumpln("BAD FASTPROPS TEST: tagValue 1"); errctr++; }
  if("1234567890"                 != userPWordTag.value){  dumpln("BAD FASTPROPS TEST: tagValue 2"); errctr++; }
  if("!@#$%^&*()"                 != userOrgTag.value){    dumpln("BAD FASTPROPS TEST: tagValue 3"); errctr++; }
  if("[]\;',./|}{:?><"            != userServerTag.value){ dumpln("BAD FASTPROPS TEST: tagValue 4"); errctr++; }
  
  if(errctr==0){
    dumpln("SUCCESS");
  }
  else{
    dumpln("FAILURE: "+errctr+" erros found");
  }
  dumpln("=== end fast props test ===");
}


