/***
JavaScript for manageing the report editor
***/
var exportMode = false;
var userDn     = null;                   // current users login dn
var curServer  = null;                   // current users org dn
var debugMode  = false;

var nameList   = null;                   // sorted list of object names involved in report

function isDebugMode()
{
  return debugMode;
}


var basisObject = null; //  The basis of the traversal
var allUsedObjectHash = new Object(); // key = object name; 
                                  // value = hash of object columns with column name
                                  //   pointing to true if in report, and false if not.

function onLoad()
{
  dumpln("loaded");
  dumpln(window.arguments[0]);

  dropDown = document.getElementById("baseObjectChoice");
  userDn    = window.arguments[0];
  curServer = window.arguments[1];
  dumpln("!!!!!"+curServer);
  var nameList  = window.arguments[2];

  var ctr;
  for(ctr=0;ctr<nameList.length;ctr++){
    appendTagAndSet(dropDown,"menuitem","label",nameList[ctr]);
  }

}



/***
set up the page where users select child objects.
***/
function loadChildSelectionPage()
{
  var relatedObjectList = document.getElementById('relatedObjectList');
  clearChildren(relatedObjectList);

  //----- How to get something out of a drop down ---------------
  dropDown = document.getElementById("baseObjectChoice");
  selectedNode = getChildNodeWhereAttrEquals(dropDown,"selected","true");
  basisObject = selectedNode.getAttribute("label");
  //-------------------------------------------------------------

  appendTagAndSet(relatedObjectList,"listitem","label",basisObject);

  addTreeItem(document.getElementById("treeRoot"), basisObject,"ROOT")

}

/**
Get the forms available on an object
**/
function loadObjectLinkDefinition(objectType)
{
  try {
    //--- Load the link definitions
    workingObjectType = objectType;
    var harmony2 = createTemplateDOM(userDn);
    var plTag = addPowerLink(harmony2, null, null);  // no link code, no comment
    addPowerLinkSide(plTag, objectType);
    setAction(harmony2,"getLinkDefineList");

    sendHarmonyRequest(harmony2, loadObjectLinkDefinitionResponse);
  } catch (e) {
    dumpln("EXC: loadFormAvailabilityList "+e);
    getStackTrace();
  }
}

/**
Get the forms available on an object
**/
function loadObjectLinkDefinitionResponse(newDoc)
{
  try {

    newDoc = firstChild(newDoc);  // get to the harmony node.

    //---- Handle the link definitions in the second response
    var result = firstChild(newDoc);
    var lDefList = getChildList(result,"power-link");
    var linkKeyArray = new Array();  // array entries are 'linkCode:farObject'
    var linkCodeMap = new Object();  // array entries are 'linkCode:farObject'

    for (ctr=0;ctr<lDefList.length;ctr++) {  // spin through the link definitions
      var linkDef = lDefList[ctr];

      var linkCodeName      = getChildValue(linkDef,"link-code");
      var linkFarSideObject = getFarSideForLinkDef(linkDef,workingObjectType)

      treeCell = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
      if(linkFarSideObject==null){
        linkFarSideObject = "[ One Sided Link ]";
      }
      addTreeItem(treeCell,linkFarSideObject,linkCodeName);
    }

  } 
  catch (e) {
    dumpln("EXC: loadFormAvailabilityListResponse "+e);
    getStackTrace();
  }
}


/***
Adds the objects available from the currently selected object in the tree.
***/
function growTree()
{
  tree = document.getElementById("objectTree");
  treeCell = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  chosenObject = treeCell.getAttribute("label");

  dumpln(">>"+chosenObject);
  loadObjectLinkDefinition(chosenObject);
}


/***
Add an item to the tree
***/
function addTreeItem(parentTag, objectType, linkCode)
{
  appendPoint = parentTag;
  if(appendPoint.tagName=="treecell"){
    appendPoint = parentTag.parentNode.parentNode;
  }
  
  if(appendPoint.tagName=="treeitem"){
    appendPoint = getChildNode(appendPoint,"treechildren");
    if(appendPoint==null){
      appendPoint = appendTagAndSet(item,"treechildren",null,null);
    }
  }


  dumpln("appendPoint:"+appendPoint.tagName);

  item = appendTagAndSet(appendPoint,"treeitem","container","true");
  item.setAttribute("open","true");

  value = appendTagAndSet(item,"treerow",null,null);

  cell  = appendTagAndSet(value,"treecell","label",objectType);
  cell  = appendTagAndSet(value,"treecell","label",linkCode);

  children = appendTagAndSet(item,"treechildren",null,null);
}



/***
Build the traversal path to this object
***/
function selectTreeItem()
{
  tree = document.getElementById("objectTree");
  treeCell = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;

  chosenObject   = treeCell.getAttribute("label");
  chosenLinkCode = nextSibling(treeCell).getAttribute("label");

  var selectedPath = "";
  var objectPath = "";
  //chosenLinkCode+":"+chosenObject;
  var curTreeItem = treeCell.parentNode.parentNode;

  while(null!=curTreeItem){
    var row = getChildNode(curTreeItem,"treerow");
    if(row!=null){
      var itemList = getChildList(row);
      chosenObject   = itemList[0].getAttribute("label");  // object type for this node
      chosenLinkCode = itemList[1].getAttribute("label");  // link code for this node
      selectedPath = chosenLinkCode+":"+chosenObject+"|"+selectedPath;
      if(objectPath!=""){
        objectPath = chosenObject+" -> "+objectPath;
      }
      else{
        objectPath = chosenObject;
      }
      curTreeItem = curTreeItem.parentNode.parentNode;
    }
    else{
      curTreeItem = null;
    }
  }

  var relatedObjectList = document.getElementById('relatedObjectList');
  var item = appendTagAndSet(relatedObjectList,"listitem","label",objectPath);
  item.setAttribute("fullPath",selectedPath);


}

/***
Removes the selected item from the list of items of interest
***/
function removeSelectedObjectItem()
{
  var relatedObjectList = document.getElementById('relatedObjectList');
  if(relatedObjectList.selectedIndex != 0){
    relatedObjectList.removeChild( relatedObjectList.selectedItem );
  }

}


/***
set up the page where users select child objects.
***/
function loadDataColumnSelectionPage()
{
  var relatedObjectList = document.getElementById('relatedObjectList');
  var objectList = getChildList(relatedObjectList);
  var ctr=0;


  for(ctr=0;ctr<objectList.length;ctr++){
    var line = objectList[ctr]
    line = line.getAttribute("label");
    dumpln(line);
    var objectsInLine = line.split(" -> ");
    var octr = 0;
    for(octr=0;octr<objectsInLine.length;octr++){
      key=objectsInLine[octr];
      allUsedObjectHash[key] = new Object();      
    }
  }

  var harmonyCommandList = createCommandListDOM();

  // need to sort the names
  nameList = new Array();
  for(var i in allUsedObjectHash){
    nameList[nameList.length] = i;
  }

  nameList = nameList.sort();
  dumpln(nameList);

  var ctr;
  for(ctr=0;ctr<nameList.length;ctr++){
    var harmony = createTemplateDOM(userDn);
    addCustomObject(harmony, nameList[ctr]);
    setAction(harmony,"getColumnList");

    addToCommandList(harmonyCommandList,harmony.firstChild,null,null);

  }

  dumpElement(harmonyCommandList.firstChild);
  debugMode = true;

  sendHarmonyRequest(harmonyCommandList, loadDataColumnSelectionPageResponse);


}

/***
Gets the columns that are defined on each object that is involved with the report
***/
function loadDataColumnSelectionPageResponse(newDoc)
{
  try{
    var parentColumnSelector = document.getElementById("columnSelector");
    var resultList = newDoc.getElementsByTagName("result");

    var ctr=0;
    for(ctr=0;ctr<nameList.length;ctr++){
      colList = resultList[ctr].getElementsByTagName("row");
      var curGroup = appendTagAndSet(parentColumnSelector,"groupbox",null,null);
      appendTagAndSet(curGroup,"caption","label",nameList[ctr]);

      var ictr;
      for(ictr=0;ictr<colList.length;ictr++){
        var name = colList[ictr].getAttribute("column");
        var checkBox = appendTagAndSet(curGroup,"checkbox","label",name);
      }
    }
  }
  catch(ex){
    dumpln(ex);
  }
}

